package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20035ReqBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20035MergeOrder extends ProtBase {
	
	private final short iTaskCode20035 = 20035;
	private Gson gson;
	private ProtStatusResBean resBean;
	
	public Jin20035MergeOrder() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public ProtStatusResBean getResBean(){
		return this.resBean;
	}
	
	public void mergeOrder(SocketCreate create, Jin20035ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
                         DataInputStream dis, Jin20035ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20035, "开始请求信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	
	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20035, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20035, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, ProtStatusResBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Jin20035ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20035, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
